#include "config.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>                                                       
#include "I2CBitBanger.h"                                                       
#include "StartArray.h"                                                         
//#include "ProgramArray240p.h"                                                 
#include "ProgramArray288p50.h"                                                 
//#include "ProgramArray480i.h"                                                 
#include "ProgramArray576i50.h"                                                 
//#include "NECIRReceiver.h"                                                    
//#include "RemoteControlButtonValues.h"                                        
//#include <EEPROM.h>               

bool writeOneByte(uint8_t slaveRegister, uint8_t value);

bool writeBytes(uint8_t slaveAddress, uint8_t slaveRegister, uint8_t* values, uint8_t numValues);

bool writeBytes(uint8_t slaveRegister, uint8_t* values, int numValues);

bool writeStartArray();

bool writeProgramArray(const uint8_t* programArray);

int readFromRegister(uint8_t segment, uint8_t reg, int bytesToRead, uint8_t* output) ;

int readFromRegister(uint8_t reg, int bytesToRead, uint8_t* output) ;

void returnToDefaultSettings() ;

void shiftHorizontal(uint16_t amountToAdd, bool subtracting) ;

void shiftHorizontalLeft() ;

void shiftHorizontalRight() ;

void scaleHorizontal(uint16_t amountToAdd, bool subtracting) ;

void scaleHorizontalSmaller() ;

void scaleHorizontalLarger() ;

void shiftVertical(uint16_t amountToAdd, bool subtracting) ;

void shiftVerticalUp() ;

void shiftVerticalDown() ;

void debugWithLED(int numBytes, uint8_t* buf) ;

void saveCurrentSettingsToBank(uint16_t bankNumber) ;

void saveCurrentSettings() ;

void loadStoredSettings(uint8_t bankNumber) ;

void setup() ;
